Debian Bug report logs - #400140
libneon26-dev: Libtool's .la file missing

version graph

Package: libneon26-dev; Maintainer for libneon26-dev is (unknown);

Reported by: Nicolás Lichtmaier <nick@reloco.com.ar>

Date: Fri, 24 Nov 2006 06:33:01 UTC

Severity: normal

Fixed in version 0.26.4-4+rm

Done: Sandro Tosi <morph@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
New Bug report received and forwarded. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Nicolás Lichtmaier <nick@reloco.com.ar>
To: submit@bugs.debian.org
Subject: libneon26-dev: Libtool's .la file missing
Date: Fri, 24 Nov 2006 03:23:40 -0300
Package: libneon26-dev
Severity: normal

Builds fail because libneon.la is missing. Neon config reports that this 
file should be in /usr/lib/libneon.la.

$ neon-config --la-file
/usr/lib/libneon.la




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Laszlo Boszormenyi <gcs@debian.hu>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #10 received at 400140@bugs.debian.org (full text, mbox):

From: Laszlo Boszormenyi <gcs@debian.hu>
To: Nicolás Lichtmaier <nick@reloco.com.ar>, 400140@bugs.debian.org
Subject: Re: Bug#400140: libneon26-dev: Libtool's .la file missing
Date: Fri, 24 Nov 2006 08:05:12 +0100
On Fri, 2006-11-24 at 03:23 -0300, Nicolás Lichtmaier wrote:
> Builds fail because libneon.la is missing.
 Which package is it?

> Neon config reports that this 
> file should be in /usr/lib/libneon.la.
 Yes, but it is removed, due to #386652 [1].

> $ neon-config --la-file
> /usr/lib/libneon.la
 I have to remove this as well then.

Thanks for reporting,
Laszlo/GCS
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=386652




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #15 received at 400140@bugs.debian.org (full text, mbox):

From: Nicolás Lichtmaier <nick@reloco.com.ar>
To: Laszlo Boszormenyi <gcs@debian.hu>
Cc: 400140@bugs.debian.org
Subject: Re: Bug#400140: libneon26-dev: Libtool's .la file missing
Date: Fri, 24 Nov 2006 04:13:04 -0300
>> Builds fail because libneon.la is missing.
>>     
>  Which package is it?
>   

No package. It's upstream, unmodified subversion.

>> Neon config reports that this 
>> file should be in /usr/lib/libneon.la.
>>     
>  Yes, but it is removed, due to #386652 [1].
>
>   
>> $ neon-config --la-file
>> /usr/lib/libneon.la
>>     
>  I have to remove this as well then.
>   

You would break the command line interface of that tool. Don't do that, 
please. That's not the solution. The subversion development package 
should depend on libneon26-dev, so that the file is always there. These 
files are meant to be installed, please check libtool docs.




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #20 received at 400140@bugs.debian.org (full text, mbox):

From: Nicolás Lichtmaier <nick@reloco.com.ar>
To: Laszlo Boszormenyi <gcs@debian.hu>
Cc: 400140@bugs.debian.org
Subject: Re: Bug#400140: libneon26-dev: Libtool's .la file missing
Date: Fri, 24 Nov 2006 04:18:25 -0300
>> Neon config reports that this 
>> file should be in /usr/lib/libneon.la.
>>     
>  Yes, but it is removed, due to #386652 [1].
>   

Me again =). Check Debian policy about .la files:

http://www.debian.org/doc/debian-policy/ch-files.html#s-libraries




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Laszlo Boszormenyi <gcs@lsc.hu>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #25 received at 400140@bugs.debian.org (full text, mbox):

From: Laszlo Boszormenyi <gcs@lsc.hu>
To: debian-release@lists.debian.org, pkg-subversion-maintainers@lists.alioth.debian.org
Cc: 400140@bugs.debian.org
Subject: neon26 and .la files
Date: Fri, 24 Nov 2006 10:16:49 +0100
[Message part 1 (text/plain, inline)]
Hi Release Team,

 I ask for a standpoint for #400140 [1] which asks for put back
library .la files into libneon26{,-gnutls-}-dev . They were removed due
to #386652 [2], where the Subversion packaging team asked for their
removal. But #400140 [1] says the upstream Subversion source can not be
compiled without them.
So should I let them back to the packages or not? I don't want to ruin
anything as we are close to Etch. The neon26 packages have big reverse
dependencies like Subversion and Openoffice.org .

Thanks in advance,
Laszlo/GCS
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=400140
[2] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=386652
[3] http://www.debian.org/doc/debian-policy/ch-files.html#s-libraries
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #30 received at 400140@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Laszlo Boszormenyi <gcs@lsc.hu>
Cc: debian-release@lists.debian.org, pkg-subversion-maintainers@lists.alioth.debian.org, 400140@bugs.debian.org
Subject: Re: neon26 and .la files
Date: Fri, 24 Nov 2006 23:53:47 -0800
On Fri, Nov 24, 2006 at 10:16:49AM +0100, Laszlo Boszormenyi wrote:

>  I ask for a standpoint for #400140 [1] which asks for put back
> library .la files into libneon26{,-gnutls-}-dev . They were removed due
> to #386652 [2], where the Subversion packaging team asked for their
> removal. But #400140 [1] says the upstream Subversion source can not be
> compiled without them.

So smack subversion upstream and tell them not to do stupid things like
referencing .la files directly.  (Also smack neon upstream for having
a --la-file option to neon-config. :)

> So should I let them back to the packages or not? I don't want to ruin
> anything as we are close to Etch. The neon26 packages have big reverse
> dependencies like Subversion and Openoffice.org .

No, if nothing in Debian needs it, please don't re-add .la files. :)

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Joe Orton <joe@manyfish.co.uk>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #35 received at 400140@bugs.debian.org (full text, mbox):

From: Joe Orton <joe@manyfish.co.uk>
To: 400140@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: neon026 and .la files
Date: Mon, 4 Dec 2006 11:20:25 +0000
`neon-config --la-file` is part of the defined and documented neon 
interface: removing the .la file breaks that interface, and hence will 
break applications designed to build against neon.  It is desirable to 
reference .la files directly when implementing simple portable build 
systems around libtool.

The vendetta against .la files, however well-intentioned, is poorly 
conceived.  If you want to fix the problem of .la files unnecessarily 
propagating private shared library dependencies then expend the effort 
to fix it *in libtool*, just as it was fixed in pkg-config with the 
introduction of Libs.private.  This is not rocket science.

Attempting to deny the existence or the utility of .la files is naive, 
and unilaterally breaking interfaces in the packaging thereof is just 
dumb.

Regards,

joe



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Ondřej Surý <ondrej@sury.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #40 received at 400140@bugs.debian.org (full text, mbox):

From: Ondřej Surý <ondrej@sury.org>
To: 400140@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: neon026 and .la files
Date: Mon, 04 Dec 2006 14:19:54 +0100
Joe Orton píše v Po 04. 12. 2006 v 11:20 +0000:
> `neon-config --la-file` is part of the defined and documented neon 
> interface: removing the .la file breaks that interface, and hence will 
> break applications designed to build against neon.  It is desirable to 
> reference .la files directly when implementing simple portable build 
> systems around libtool.

Hence Debian package needs to remove that option from neon-config
and document this change in documentation (README.Debian and patch
existing docs).

Applications which directly access .la files should be fixed.

Ondrej.
-- 
Ondřej Surý <ondrej@sury.org> ^_^ http://blog.rfc1925.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #45 received at 400140@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Joe Orton <joe@manyfish.co.uk>
Cc: 400140@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: neon026 and .la files
Date: Tue, 5 Dec 2006 02:16:06 -0800
On Mon, Dec 04, 2006 at 11:20:25AM +0000, Joe Orton wrote:
> `neon-config --la-file` is part of the defined and documented neon 
> interface: removing the .la file breaks that interface,

It's a shitty interface that warrants breaking.

> and hence will break applications designed to build against neon.

s/designed to build against neon/perversely making use of mis-designed interfaces/

>  It is desirable to reference .la files directly

No, it is not.  .la files were designed to be *internal* to libtool.

> The vendetta against .la files, however well-intentioned, is poorly 
> conceived.  If you want to fix the problem of .la files unnecessarily 
> propagating private shared library dependencies then expend the effort 
> to fix it *in libtool*, just as it was fixed in pkg-config with the 
> introduction of Libs.private.  This is not rocket science.

Cool, you're so smart, *you* write the fix and get it accepted by libtool
upstream.

Until then, .la files are a pox, and I have no sympathy for anyone who
depends on them.

> Attempting to deny the existence or the utility of .la files is naive,

They're only useful on broken platforms and when doing static linking.
Recent pkg-config has better provisions for the latter, and the former
should be encouraged to die out so that they stop making life harder for
those of us running systems that aren't built on 1980s technology.

> and unilaterally breaking interfaces in the packaging thereof is just 
> dumb.

Not nearly as dumb as violating abstractions and depending on dumb
interfaces in the first place, kthx.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Peter Samuelson <peter@p12n.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #50 received at 400140@bugs.debian.org (full text, mbox):

From: Peter Samuelson <peter@p12n.org>
To: Joe Orton <joe@manyfish.co.uk>
Cc: 400140@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: neon026 and .la files
Date: Tue, 5 Dec 2006 15:27:04 -0600
[Message part 1 (text/plain, inline)]
[Joe Orton]
> `neon-config --la-file` is part of the defined and documented neon
> interface: removing the .la file breaks that interface, and hence
> will break applications designed to build against neon.

So, I was the one who requested that the neon26 maintainer remove the
.la file.  I'll incorporate Ondrej and Steve's comments by reference
here - suffice it to say Debian has good reasons to want to phase out
.la files entirely, if possible.

As for 'neon-config --la-file', I am curious why it even exists.  Is
not 'neon-config --libs' just as effective?  If you pass "-lneon" to
libtool --mode=link, it looks for the .la file anyway and uses it if
found.  So even on platforms where the .la file adds real value,
'neon-config --libs' should still work perfectly.

As for Debian, changing 'neon-config --la-file' to be a synonym for
'neon-config --libs' is probably the right thing to do.

Peter
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Joe Orton <joe@manyfish.co.uk>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #55 received at 400140@bugs.debian.org (full text, mbox):

From: Joe Orton <joe@manyfish.co.uk>
To: Peter Samuelson <peter@p12n.org>
Cc: 400140@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: neon026 and .la files
Date: Wed, 6 Dec 2006 12:30:09 +0000
Hi Peter,

On Tue, Dec 05, 2006 at 03:27:04PM -0600, Peter Samuelson wrote:
> [Joe Orton]
> > `neon-config --la-file` is part of the defined and documented neon
> > interface: removing the .la file breaks that interface, and hence
> > will break applications designed to build against neon.
> 
> So, I was the one who requested that the neon26 maintainer remove the
> .la file.  I'll incorporate Ondrej and Steve's comments by reference
> here - suffice it to say Debian has good reasons to want to phase out
> .la files entirely, if possible.

Debian has good reasons to want to avoid propagating unnecessary shared 
library dependencies.  You can achieve that goal using a trival sed 
command for neon:

  sed -i "s/^\(dependency_libs\).*/\1='-lneon'/" libneon.la

which avoids breaking the neon interface.  This is correct for current 
versions of neon iff you don't care about supporting static linking via 
the .la file.

For libraries where the API of dependencies may leak through to the 
application, naively removing the .la file hides *necessary* shared 
library dependencies, which is simply unsafe.  That's why the only safe 
way to fix this problem in general is at libtool level, as I mentioned 
before.

(there are several cases in libraries I deal with: Subversion leaks the 
APR API, APR-util leaks the OpenLDAP API, OpenLDAP and PostgreSQL both 
leak the OpenSSL API)

> As for 'neon-config --la-file', I am curious why it even exists.  Is 
> not 'neon-config --libs' just as effective?

Using the .la file is unambigious in cases where you have more than one 
libneon.so in the library path; libtool will link against the correct 
.so using an absolute path if given the absolute path to the .la, which 
cannot be achieved in the general case using --libs.

Regards,

joe



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Emmanuel Fleury <emmanuel.fleury@labri.fr>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #60 received at 400140@bugs.debian.org (full text, mbox):

From: Emmanuel Fleury <emmanuel.fleury@labri.fr>
To: 400140@bugs.debian.org
Subject: Missing /usr/lib/libneon.la file
Date: Fri, 22 Dec 2006 19:04:02 +0100
I confirm Bug #400140. I had the same problem compiling some apps.

Regards
-- 
Emmanuel Fleury              | Office: 211
Associate Professor,         | Phone: +33 (0)5 40 00 35 24
LaBRI, Domaine Universitaire | Fax:   +33 (0)5 40 00 66 69
351, Cours de la Libération  | email: fleury@labri.fr
33405 Talence Cedex, France  | URL: http://www.labri.fr/~fleury



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #65 received at 400140@bugs.debian.org (full text, mbox):

From: Nicolás Lichtmaier <nick@reloco.com.ar>
To: 400140@bugs.debian.org, Peter Samuelson <peter@p12n.org>
Subject: Libtoo .la file in libneon26-dev.
Date: Sun, 01 Apr 2007 17:16:48 -0300
In bug #386652 you removed the .la file of neon. This shows a 
misunderstunding about what .la files are.

Subversion development packages should refer to libneon.la, there's no 
problem with that.

Please, restore that file, as the package is currently borken. I need to 
work with a custom made neon package now =(.

Thanks!



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Peter Samuelson <peter@p12n.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #70 received at 400140@bugs.debian.org (full text, mbox):

From: Peter Samuelson <peter@p12n.org>
To: Nicolás Lichtmaier <nick@reloco.com.ar>
Cc: 400140@bugs.debian.org
Subject: Re: Libtoo .la file in libneon26-dev.
Date: Sun, 1 Apr 2007 17:31:07 -0500
[Message part 1 (text/plain, inline)]
[Nicolás Lichtmaier]
> In bug #386652 you removed the .la file of neon. This shows a 
> misunderstunding about what .la files are.

We know what .la files are.  They are internal metadata maintained and
used by libtool, that everyone _except_ libtool shouldn't need to care
about.  Talking about a .la file when you aren't libtool is a layering
violation of sorts.

> Please, restore that file, as the package is currently borken. I need
> to work with a custom made neon package now =(.

I'd suggest becoming accustomed to using either 'pkg-config --libs
neon' or 'neon-config --libs', rather than 'neon-config --la-file'.
Referring directly to a .la file outside libtool is not useful in
Debian, if indeed it is useful anywhere.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#400140; Package libneon26-dev. Full text and rfc822 format available.

Acknowledgement sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. Full text and rfc822 format available.

Message #75 received at 400140@bugs.debian.org (full text, mbox):

From: Nicolás Lichtmaier <nick@reloco.com.ar>
To: Peter Samuelson <peter@p12n.org>
Cc: 400140@bugs.debian.org
Subject: Re: Libtoo .la file in libneon26-dev.
Date: Sun, 01 Apr 2007 19:44:54 -0300
>> In bug #386652 you removed the .la file of neon. This shows a 
>> misunderstunding about what .la files are.
>>     
> We know what .la files are.  They are internal metadata maintained and
> used by libtool, that everyone _except_ libtool shouldn't need to care
> about.  Talking about a .la file when you aren't libtool is a layering
> violation of sorts.
>   

And why do you think that neon installs it by default? Please, read the 
documentation, e.g.:  
http://www.gnu.org/software/libtool/manual.html#Installing-libraries .

>> Please, restore that file, as the package is currently borken. I need
>> to work with a custom made neon package now =(.
>>     
>
> I'd suggest becoming accustomed to using either 'pkg-config --libs
> neon' or 'neon-config --libs', rather than 'neon-config --la-file'.
> Referring directly to a .la file outside libtool is not useful in
> Debian, if indeed it is useful anywhere.
>   

You are wrong. These .la files are used to provide libtool programs 
using the library information both at runtime (in case of dlopen) and 
when building (version info, dependencies, etc.). If you are in doubt, 
go to /usr/lib and do an ls *.la.

Please, put it back where it was.




Reply sent to Sandro Tosi <morph@debian.org>:
You have taken responsibility. (Tue, 13 Jul 2010 16:57:03 GMT) Full text and rfc822 format available.

Notification sent to Nicolás Lichtmaier <nick@reloco.com.ar>:
Bug acknowledged by developer. (Tue, 13 Jul 2010 16:57:03 GMT) Full text and rfc822 format available.

Message #80 received at 400140-done@bugs.debian.org (full text, mbox):

From: Sandro Tosi <morph@debian.org>
To: 558525-done@bugs.debian.org, 558939-done@bugs.debian.org, 400140-done@bugs.debian.org
Cc: Sandro Tosi <morph@debian.org>
Subject: neon26 removed from Debian unstable
Version: 0.26.4-4+rm

neon26 has been removed from Debian unstable: http://bugs.debian.org/581888

Closing its bugs with a Version higher than the last unstable upload.

More information about this script at:
  http://git.debian.org/?p=users/morph/mass-bugs-close.git;a=blob_plain;f=README;hb=HEAD




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 11 Aug 2010 07:44:23 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 12:46:05 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.